/*
 * File         : Array1Type.in.java
 * Author       : Guansong Zhang
 * Created      : Tue Nov  4 14:42:42 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/04/07 19:40:22 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Array1Int extends Section1 {
  
  public Array1Int(Range x, Group group) {
    super(4); // for Int

    this.group=group;

    this.range[0]=x;

    int size=1;
    this.stride[0] = this.range[0].stride(size);
    size=this.stride[0].size;

    DAD dad=new DAD(group, this.range, this.stride);
    this.dad=dad;

    this.offset=0;

    data=new int[size];

    this.reference=data;

  }

//   public Array1Int(Range x) {
//     this(x, Spmd.apg);
//   }

  public Array1Int(Section1 sec) {
    super(4); // for Int

    this.group=sec.group;

    this.range[0]=sec.range[0];
    this.stride[0]=sec.stride[0];

    this.dad=sec.dad;

    this.offset=sec.offset;
    this.reference=sec.reference;

    this.data=(int[])sec.reference;
  }
    
  public Array0Int section(Location loc) {
    Section0 sec=this.subsec(loc);

    Array0Int array=new Array0Int(sec);

    return array;
  }

  public Array1Int section(Range range) {
    Section1 sec=this.subsec(range);

    Array1Int array=new Array1Int(sec);

    return array;
  }

  public int data[];

};
