/*
 * File         : Array2Type.in.java
 * Author       : Guansong Zhang
 * Created      : Tue Nov  4 15:45:20 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/04/07 19:40:23 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Array2Float extends Section2 {
  
  public Array2Float(Range r0, Range r1, Group group) {
    super(6); // for Float

    this.group=group;

    this.range[0]=r0;
    this.range[1]=r1;

    int size=1;
    this.stride[0] = this.range[0].stride(size);
    this.stride[1] = this.range[1].stride(this.stride[0].size);
    size=this.stride[1].size;
    
    DAD dad=new DAD(group, this.range, this.stride);
    this.dad=dad;

    this.offset=0;

    data=new float[size];

    this.reference=data;

  }

//   public Array2Float(Range r0, Range r1) {
//     this(r0, r1, Spmd.apg);
//   }

  public Array2Float(Section2 sec) {
    super(6); // for Float

    this.group=sec.group;

    this.range[0]=sec.range[0];
    this.range[1]=sec.range[1];

    this.stride[0]=sec.stride[0];
    this.stride[1]=sec.stride[1];

    this.dad=sec.dad;

    this.offset=sec.offset;
    this.reference=sec.reference;

    this.data=(float[])sec.reference;
  }
  
  public Array0Float section(Location loc0, Location loc1) {
    Section0 sec=this.subsec(loc0, loc1);

    Array0Float array=new Array0Float(sec);

    return array;
  }

  public Array1Float section(Range rng0, Location loc1) {
    Section1 sec=this.subsec(rng0, loc1);

    Array1Float array=new Array1Float(sec);

    return array;
  }

  public Array1Float section(Location loc0, Range rng1) {
    Section1 sec=this.subsec(loc0, rng1);

    Array1Float array=new Array1Float(sec);

    return array;
  }

  public Array2Float section(Range rng0, Range rng1) {
    Section2 sec=this.subsec(rng0, rng1);

    Array2Float array=new Array2Float(sec);

    return array;
  }

  public float data[];

};

