/*
 * File         : Array3Type.in.java
 * Author       : Guansong Zhang
 * Created      : Thu Dec 18 12:08:00 1997
 * Revision     : $Revision: 1.3 $
 * Updated      : $Date: 1998/04/07 19:40:23 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1997
 */

package spmd;

import spmd.*;

public class Array3Float extends Section3 {

  public Array3Float(Range rng0, Range rng1, Range rng2, Group group) {
    super(6); // for Float

    this.group=group;
    
    this.range[0]=rng0;
    this.range[1]=rng1;
    this.range[2]=rng2;

    int size=1;
    this.stride[0] = this.range[0].stride(size);
    this.stride[1] = this.range[1].stride(this.stride[0].size);
    this.stride[2] = this.range[2].stride(this.stride[1].size);
    size=this.stride[2].size;

    DAD dad=new DAD(group, this.range, this.stride);
    this.dad=dad;

    this.offset=0;

    data=new float[size];

    this.reference=data;

  }

//   public Array3Float(Range rng0, Range rng1, Range rng2) {
//     this(rng0, rng1, rng2, Spmd.apg);
//   }

  public Array3Float(Section3 sec) {
    super(6); // for Float

    this.group=sec.group;

    this.range[0]=sec.range[0];
    this.range[1]=sec.range[1];
    this.range[2]=sec.range[2];

    this.stride[0]=sec.stride[0];
    this.stride[1]=sec.stride[1];
    this.stride[2]=sec.stride[2];

    this.dad=sec.dad;

    this.offset=sec.offset;
    this.reference=sec.reference;

    this.data=(float[])sec.reference;
  }
    
  public Array0Float section(Location loc0, Location loc1, Location loc2) {
    Section0 sec=this.subsec(loc0, loc1, loc2);

    Array0Float array=new Array0Float(sec);

    return array;
  }

  public Array1Float section(Range rng0, Location loc1, Location loc2) {
    Section1 sec=this.subsec(rng0, loc1, loc2);

    Array1Float array=new Array1Float(sec);

    return array;
  }

  public Array1Float section(Location loc0, Range rng1, Location loc2) {
    Section1 sec=this.subsec(loc0, rng1, loc2);

    Array1Float array=new Array1Float(sec);

    return array;
  }

  public Array1Float section(Location loc0, Location loc1, Range rng2) {
    Section1 sec=this.subsec(loc0, loc1, rng2);

    Array1Float array=new Array1Float(sec);

    return array;
  }

  public Array2Float section(Range rng0, Range rng1, Location loc2) {
    Section2 sec=this.subsec(rng0, rng1, loc2);

    Array2Float array=new Array2Float(sec);

    return array;
  }

  public Array2Float section(Range rng0, Location loc1, Range rng2) {
    Section2 sec=this.subsec(rng0, loc1, rng2);

    Array2Float array=new Array2Float(sec);

    return array;
  }

  public Array2Float section(Location loc0, Range rng1, Range rng2) {
    Section2 sec=this.subsec(loc0, rng1, rng2);

    Array2Float array=new Array2Float(sec);

    return array;
  }

  public Array3Float section(Range rng0, Range rng1, Range rng2) {
    Section3 sec=this.subsec(rng0, rng1, rng2);

    Array3Float array=new Array3Float(sec);

    return array;
  }

  public float data[];

} 
