
// Operations on level-0 ranges.


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `DimRangeRep': process dimension range.                       //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class DimRangeRep : public RangeRep {
public : 
  DimRangeRep() : RangeRep(1, 0, 0, Dimension(), DIST_PRIMITIVE) {}

  DimRangeRep(Dimension _dim) : RangeRep(_dim ? _dim.size() : 1, 0, 0, _dim,
                                         DIST_PRIMITIVE) {}

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  RangeRep* ker() const ;

  void location(Location* loc, const int glb) const ;

  int local(int* glb) const ;

  RangeRep* subker() const ;

  int volume() const ;
  int offset(const Location*) const ;

  int disp(const int) const ;
  int step(const int) const ;

  void show() ;

MEMORY_POOL_DECS
} ;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
//                                                                     //
// class `DimSubRangeRep': process dimension subrange.                 //
//                                                                     //
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //

class DimSubRangeRep : public SubRangeRep {
public :
  DimSubRangeRep(const int _extent, const int _base, const int _stride,
                 RangeRep* _parent, Dimension _dim) :
          SubRangeRep(_extent, _base, _stride, _parent, 0, 0, _dim,
                      DIST_PRIMITIVE) {}

  RangeRep* subrng(const int _extent, const int _base, const int _stride) ;

  RangeRep* ker() const ;

  void location(Location* loc, const int glb) const ;

  int local(int* glb) const ;

  int volume() const ;
  int offset(const Location*) const ;

  int disp(const int) const ;
  int step(const int) const ;

  RangeRep* subker() const ;

  int glb(const int sub, const int ker_glb) const ;

  void show() ;

MEMORY_POOL_DECS
} ;


// -------------------------------------------------------------
// Things to do
//

